{$D-,L-,Y-}
{$E-,N+,G+}
{$S-}
{$M 4096 0 0}
uses timer,kbd,dos;
var lcd_arr:array[0..200]of array[0..10]of byte;




procedure lcd_rst;
begin
port[$378]:=$E8;
xdelay(50);
port[$378]:=$F8;
xdelay(50);
end;



procedure lcd_off;
begin
port[$378]:=$00;
xdelay(50);
end;






procedure lcd_wrbyte_d(val:byte);
var tmpb:byte;
begin
port[$378]:=port[$378] and $F7;
port[$378]:=port[$378] or $04;
tmpb:=$80;
repeat
if (val and tmpb>0) then port[$378]:=port[$378] or $02
                    else port[$378]:=port[$378] and $FD;
port[$378]:=port[$378] or $01;
port[$378]:=port[$378] and $FE;
tmpb:=tmpb shr 1;
until tmpb=0;
port[$378]:=port[$378] or $08;
end;



procedure lcd_wrbyte_c(val:byte);
var tmpb:byte;
begin
port[$378]:=port[$378] and $F7;
port[$378]:=port[$378] and $FB;
tmpb:=$80;
repeat
if (val and tmpb>0) then port[$378]:=port[$378] or $02
                    else port[$378]:=port[$378] and $FD;
port[$378]:=port[$378] or $01;
port[$378]:=port[$378] and $FE;
tmpb:=tmpb shr 1;
until tmpb=0;
port[$378]:=port[$378] or $08;
end;




procedure lcd_setpix(x,y:byte);
begin
if (x<96)and(y<65) then begin
lcd_arr[x,(y div 8)]:=lcd_arr[x,(y div 8)] or (1 shl (y mod 8));
lcd_wrbyte_c($40+(y div 8));
lcd_wrbyte_c($80+x);
lcd_wrbyte_d(lcd_arr[x,(y div 8)]);
end;
end;



procedure lcd_clrpix(x,y:byte);
begin
if (x<96)and(y<65) then begin
lcd_arr[x,(y div 8)]:=lcd_arr[x,(y div 8)] and(   not(1 shl (y mod 8))   );
lcd_wrbyte_c($40+(y div 8));
lcd_wrbyte_c($80+x);
lcd_wrbyte_d(lcd_arr[x,(y div 8)]);
end;
end;



procedure lcd_invpix(x,y:byte);
begin
if (x<96)and(y<65) then begin
lcd_arr[x,(y div 8)]:=lcd_arr[x,(y div 8)] xor(   (1 shl (y mod 8))   );
lcd_wrbyte_c($40+(y div 8));
lcd_wrbyte_c($80+x);
lcd_wrbyte_d(lcd_arr[x,(y div 8)]);
end;
end;



procedure lcd_redraw;
var x,y:byte;
begin
for y:=0 to 8 do begin
lcd_wrbyte_c($40+(y));
lcd_wrbyte_c($80);
for x:=0 to 95 do lcd_wrbyte_d(lcd_arr[x,y]);
end;
end;








var
i:byte;
reg:registers;

mb,mb_old:byte;
mx,mx_old:byte;
my,my_old:byte;



begin
reg.ax:=$0000;
intr($33,reg);

reg.ax:=$0001;
intr($33,reg);

reg.ax:=$0007;
reg.cx:=0;
reg.dx:=95*8{639};
intr($33,reg);

reg.ax:=$0008;
reg.cx:=0;
reg.dx:=64*8{199};
intr($33,reg);



lcd_rst;
lcd_wrbyte_c($21);
lcd_wrbyte_c($04+(0 and $03));
lcd_wrbyte_c($10+(0 and $07));
lcd_wrbyte_c($80+(0 and $7F));
lcd_wrbyte_c($20);

lcd_wrbyte_c($80+(10 and $7F));
lcd_wrbyte_c($40+(1 and $3F));
lcd_wrbyte_c($0C);


lcd_redraw;

for i:=0 to 40 do
lcd_setpix(i,i);

repeat
reg.ax:=3;
intr($33,reg);
mb:=reg.bx;
mx:=reg.cx div 8;
my:=reg.dx div 8;
if (mx<>mx_old) or (my<>my_old) then begin
lcd_invpix(mx_old,my_old);
lcd_invpix(mx,my);
mx_old:=mx;
my_old:=my;
end;

if (mb and $02>0) then lcd_setpix(mx,my);
if (mb and $01>0) then lcd_clrpix(mx,my);

until xkeypr;




gkey;
lcd_off;
reg.ax:=$0002;
intr($33,reg);
end.